> For the complete documentation index, see [llms.txt](https://docs.tessl.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tessl.io/reference/custom-agent-setup/openclaw.md).

# OpenClaw

### OpenClaw

OpenClaw is an autonomous AI agent framework with its own workspace and skills system. Tessl integrates with OpenClaw by installing skills directly into an agent workspace — no MCP configuration or rules files are used, to keep config clean.

### How skills work with OpenClaw

Tessl installs skills as symlinks into the `skills/` directory of your OpenClaw agent workspace. OpenClaw reads skills from this directory automatically.

Skills installed by Tessl are prefixed with `tessl__` so they can be identified and managed separately from your other skills, if necessary.

### Installing skills

Navigate to your agent workspace directory before running `tessl install`. A workspace is identified by the presence of a `.openclaw/workspace-state.json` file.

```bash
cd ~/.openclaw/workspace   # or whichever workspace you want to install into
tessl install plugin-name
```

If you run `tessl install` from anywhere other than a workspace root, Tessl will exit with an error and suggest the correct directories to navigate to.

### Multiple agents

If you have more than one OpenClaw agent, run `tessl install` separately from each workspace:

```bash
cd ~/.openclaw/workspaces/agent1
tessl install plugin-name

cd ~/.openclaw/workspaces/agent2
tessl install plugin-name
```

### Installing for coding agents at the same time

If your OpenClaw agent uses coding agents (Claude Code, Codex, etc.), use the `--agent` flag to control which agents receive skills:

```bash
# Install for both OpenClaw and a coding agent
tessl install plugin-name --agent openclaw --agent claude-code

# Install for a coding agent only, skip OpenClaw
tessl install plugin-name --agent claude-code
```

With no `--agent` flag, Tessl auto-detects which agents are present in the workspace directory, and installs for all of them.

### Using tessl init

`tessl init` is not supported in OpenClaw workspaces. If you run it from a workspace root, Tessl will exit with an error and prompt you to run tessl install instead.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tessl.io/reference/custom-agent-setup/openclaw.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
